using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient ;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace Grouping
{
	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
	public class Report : System.Web.UI.Page
	{
		protected static string connstring = "server=(local); initial catalog=northwind; uid=sa; pwd=;" ;
		protected SqlConnection conn = new SqlConnection(connstring) ;
		DataSet ds = new DataSet() ;
		DataView dv ;
		protected System.Web.UI.WebControls.Repeater rptCategories ;
		protected System.Web.UI.WebControls.Repeater rptProducts ;
		protected decimal SalesTotal ;
		
		private void Page_Load(object sender, System.EventArgs e)
		{
			if(!IsPostBack)
			{			
				rptCategories.DataSource = getSalesbyCategory() ;
				rptCategories.DataBind() ;	
			}
		}

		private DataSet getSalesbyCategory()
		{
			SqlCommand cmd = new SqlCommand("SALES_Report", conn) ;
			cmd.CommandType = CommandType.StoredProcedure ;
			SqlDataAdapter da =new SqlDataAdapter(cmd) ;
			da.Fill(ds) ;
			ds.Tables[0].TableName = "Categories" ;
			ds.Tables[1].TableName = "Products" ;										
			return ds ;
		}

		private DataView getChildRows(string Filter)
		{
			string whereClause = string.Format("CategoryName = '{0}'", Filter) ;
			DataView dv = new DataView(ds.Tables["Products"], whereClause, "", DataViewRowState.CurrentRows) ;	
			return dv ;
		}	

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.rptCategories.ItemDataBound += new System.Web.UI.WebControls.RepeaterItemEventHandler(this.rptCategories_ItemDataBound);
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion

		private void rptCategories_ItemDataBound(object sender, System.Web.UI.WebControls.RepeaterItemEventArgs e)
		{
			if(e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
			{
				// find category in RepeaterItem
				string category = ((DataRowView)e.Item.DataItem).Row.ItemArray[0].ToString();
				Repeater rep = (Repeater)e.Item.FindControl("rptProducts") ;
				// pass in category to construct "where clause", then set DataView as DataSource
				dv = getChildRows(category) ;
				rep.DataSource = dv ;
				rep.DataBind() ;		
		
				// calculate total for product category
				SalesTotal = this.calculateSalesTotals(category) ;
	
				// Find item in group "footer" and populate label with total
				Repeater r = (Repeater)e.Item.Parent ;
				Label lblSalesTotals = (Label)r.Controls[e.Item.ItemIndex + 1].FindControl("lblSalesTotals") ;
				lblSalesTotals.Text = SalesTotal.ToString("C") ;
			}
		}

		protected void rptProducts_ItemDataBound(object sender, System.Web.UI.WebControls.RepeaterItemEventArgs e)
		{
			if(e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
			{
				string product = ((DataRowView)e.Item.DataItem).Row.ItemArray[2].ToString() ;
				ImageButton i = (ImageButton)e.Item.Controls[0].FindControl("imgDelete") ;
				i.CommandName = "Delete" ;
				i.CommandArgument = product ;
				string script = string.Format("javascript:alert('Delete Product: {0}');", product) ;
				i.Attributes.Add("onclick", script) ;	
			}
		}

		protected decimal calculateSalesTotals(string category)
		{
			decimal sales = 0 ;

			foreach(DataRowView drv in dv)
			{
				sales += System.Decimal.Parse(drv.Row["ProductSales"].ToString()) ;
			}
			return sales ;
		}

		protected void imgDelete_Command(object sender, System.Web.UI.WebControls.CommandEventArgs e)
		{
			System.Diagnostics.Debug.WriteLine(e.CommandArgument.ToString()) ;	
		}
	}
}
